<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Entity\PortalEntity;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\PostalCodeEntity;

use RxConnexionBundle\Form\PostalCodeForm;

/**
 * @Route("/main/postal_code")
 */
class PostalCodeController extends Controller
{
    /**
     * @Route("", name="postal_code")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Postal Code'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/PostalCode/index.html.twig', array(
            'title' => 'Manage Postal Code',
            'page_title' => 'Manage Postal Code',
            'javascripts' => array('rxconnexion/admin/js/postalCode/postalCode.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="postal_code_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Postal Code Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:PostalCodeEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('postal_code_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['city_desc'],
                    $row['code'],
                    $row['description'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "postal_code_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Postal Code New', 'Admin Postal Code Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $postalCode = $em->getRepository('RxConnexionBundle:PostalCodeEntity')->find(base64_decode($id));
        if(!$postalCode) {
            $postalCode = new PostalCodeEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(PostalCodeForm::class, $postalCode, $formOptions);

        if($request->getMethod() === 'POST') {

            $postalCode_form = $request->get($form->getName());
            $result = $this->processForm($postalCode_form, $postalCode, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('postal_code'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('postal_code_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('postal_code_form'), 302);
                }
            } else {
                $form->submit($postalCode_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Postal Code';

        return $this->render('@RxConnexion/PostalCode/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/postalCode/postalCode_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($postalCode_form, $postalCode, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:PostalCodeEntity')->validate($postalCode_form);

        if(!count($errors)) {

            switch($postalCode_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($postalCode);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Postal Code',
                            $em->getClassMetadata(PostalCodeEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $postalCode;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Postal Code',
                        $em->getClassMetadata(PostalCodeEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $postalCode;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Postal Code',
                        $em->getClassMetadata(PostalCodeEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $postalCode;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($postalCode);
                        $postalCode->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="postal_code_autocomplete")
     */
    public function autocompleteAction(Request $request) {
        $city_id = $request->get('city_id');
        $q = $request->get('query');
        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:PostalCodeEntity')->autocomplete_suggestions($q, $city_id)
        );

        return new JsonResponse($result);
    }

    /**
     * @Route("/autocomplete_for_map", name="postal_code_autocomplete_for_map")
     */
    public function autocomplete_for_mapAction(Request $request) {

        $city_id = $request->get('city_id');
        $q = $request->get('query');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:PostalCodeEntity')->autocomplete_suggestions_for_map($q, $city_id)
        );

        return new JsonResponse($result);
    }
}
